#pragma once
#include <QWidget>
#include <QFrame>
#include <BehaviorPerform.h>
#include <QLineEdit>
#include <QTableView>
#include <QStandardItemModel>
#include <QDialog>
#include <QComboBox>
#include "sims_world.h"

class VariableAdd : public QDialog {
private:
	std::shared_ptr<BehaviorMapNode> _bind_node = nullptr;

	QComboBox *const _io_type;
	QComboBox *const _data_type;
	QLineEdit *const _var_name;

public:
	VariableAdd(std::shared_ptr<BehaviorMapNode> node, QWidget *parent = nullptr);

	void appendVariable();
};

class NodePresent;
class BehaviorMapConfigurationPanel : public QFrame, public NodeConfiguration
{
	Q_OBJECT
private:
	QLineEdit *const _root_name;
	QTableView *const _variable_table;
	QStandardItemModel *const _variable_model;

	std::shared_ptr<BehaviorMapNode> _bind_node;	// ݽ
	NodePresent *_bind_graph = nullptr;				// ͼʾ

public:
	BehaviorMapConfigurationPanel(QWidget *p = nullptr);

	void setTarget(NodePresent *ins) override;
};

